## com.fasterxml.jackson.core.json
Class UTF8JsonGenerator

    java.lang.Object
      com.fasterxml.jackson.core.JsonGenerator
          com.fasterxml.jackson.core.base.GeneratorBase
              com.fasterxml.jackson.core.json.UTF8JsonGenerator

All Implemented Interfaces:
  Versioned, Closeable

    public class UTF8JsonGenerator

extends GeneratorBase

Nested Class Summary

Nested classes/interfaces inherited from class com.fasterxml.jackson.core.JsonGenerator
`JsonGenerator.Feature`

Field Summary
`protected boolean` `_bufferRecyclable` Flag that indicates whether the output buffer is recycable (and needs to be returned to recycler once we are done) or not.
`protected CharacterEscapes` `_characterEscapes` Definition of custom character escapes to use for generators created by this factory, if any.
`protected char[]` `_charBuffer` Intermediate buffer in which characters of a String are copied before being encoded.
`protected int` `_charBufferLength` Length of `_charBuffer`
`protected byte[]` `_entityBuffer` 6 character temporary buffer allocated if needed, for constructing escape sequences
`protected IOContext` `_ioContext`
`protected int` `_maximumNonEscapedChar` Value between 128 (0x80) and 65535 (0xFFFF) that indicates highest Unicode code point that will not need escaping; or 0 to indicate that all characters can be represented without escaping.
`protected byte[]` `_outputBuffer` Intermediate buffer in which contents are buffered before being written using `_outputStream`.
`protected int` `_outputEnd` End marker of the output buffer; one past the last valid position within the buffer.
`protected int[]` `_outputEscapes` Currently active set of output escape code definitions (whether and how to escape or not) for 7-bit ASCII range (first 128 character codes).
`protected int` `_outputMaxContiguous` Maximum number of `char`s that we know will always fit in the output buffer after escaping
`protected OutputStream` `_outputStream` Underlying output stream used for writing JSON content.
`protected int` `_outputTail` Pointer to the position right beyond the last character to output (end marker; may be past the buffer)
`protected static int[]` `sOutputEscapes` This is the default set of escape codes, over 7-bit ASCII range (first 128 character codes), used for single-byte UTF-8 characters.
`protected static int` `SURR1_FIRST`
`protected static int` `SURR1_LAST`
`protected static int` `SURR2_FIRST`
`protected static int` `SURR2_LAST`

Fields inherited from class com.fasterxml.jackson.core.base.GeneratorBase
`_cfgNumbersAsStrings, _closed, _features, _objectCodec, _writeContext`

Fields inherited from class com.fasterxml.jackson.core.JsonGenerator
`_cfgPrettyPrinter`

Constructor Summary
`UTF8JsonGenerator(IOContext ctxt, int features, ObjectCodec codec, OutputStream out)`
`UTF8JsonGenerator(IOContext ctxt, int features, ObjectCodec codec, OutputStream out, byte[] outputBuffer, int outputOffset, boolean bufferRecyclable)`

Method Summary
`protected int` `_decodeSurrogate(int surr1, int surr2)`
`protected void` `_flushBuffer()`
`protected void` `_outputSurrogates(int surr1, int surr2)`
`protected void` `_releaseBuffers()`
`protected void` `_verifyPrettyValueWrite(String typeMsg, int status)`
`protected void` `_verifyValueWrite(String typeMsg)`
`protected void` `_writeBinary(Base64Variant b64variant, byte[] input, int inputPtr, int inputEnd)`
`protected void` `_writeFieldName(SerializableString name)`
`protected void` `_writeFieldName(String name)`
`protected void` `_writePPFieldName(SerializableString name, boolean commaBefore)`
`protected void` `_writePPFieldName(String name, boolean commaBefore)` Specialized version of `_writeFieldName`, off-lined to keep the "fast path" as simple (and hopefully fast) as possible.
`void` `close()` Method called to close this generator, so that no more content can be written.
`void` `flush()` Method called to flush any buffered content to the underlying target (output stream, writer), and to flush the target itself as well.
`CharacterEscapes` `getCharacterEscapes()` Method for accessing custom escapes factory uses for `JsonGenerator`s it creates.
`int` `getHighestEscapedChar()` Accessor method for testing what is the highest unescaped character configured for this generator.
`Object` `getOutputTarget()` Method that can be used to get access to object that is used as target for generated output; this is usually either `OutputStream` or `Writer`, depending on what generator was constructed with.
`JsonGenerator` `setCharacterEscapes(CharacterEscapes esc)` Method for defining custom escapes factory uses for `JsonGenerator`s it creates.
`JsonGenerator` `setHighestNonEscapedChar(int charCode)` Method that can be called to request that generator escapes all character codes above specified code point (if positive value); or, to not escape any characters except for ones that must be escaped for the data format (if -1).
`Version` `version()` Implemented with detection that tries to find "VERSION.txt" in same package as the implementation class.
`void` `writeBinary(Base64Variant b64variant, byte[] data, int offset, int len)` Method that will output given chunk of binary data as base64 encoded, as a complete String value (surrounded by double quotes).
`void` `writeBoolean(boolean state)` Method for outputting literal Json boolean value (one of Strings 'true' and 'false').
`void` `writeEndArray()` Method for writing closing marker of a JSON Array value (character ']'; plus possible white space decoration if pretty-printing is enabled).
`void` `writeEndObject()` Method for writing closing marker of a JSON Object value (character '}'; plus possible white space decoration if pretty-printing is enabled).
`void` `writeFieldName(SerializableString name)` Method similar to `JsonGenerator.writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.
`void` `writeFieldName(String name)` Method for writing a field name (JSON String surrounded by double quotes: syntactically identical to a JSON String value), possibly decorated by white space if pretty-printing is enabled.
`void` `writeNull()` Method for outputting literal Json null value.
`void` `writeNumber(BigDecimal value)` Method for outputting indicate Json numeric value.
`void` `writeNumber(BigInteger value)` Method for outputting given value as Json number.
`void` `writeNumber(double d)` Method for outputting indicate Json numeric value.
`void` `writeNumber(float f)` Method for outputting indicate Json numeric value.
`void` `writeNumber(int i)` Method for outputting given value as Json number.
`void` `writeNumber(long l)` Method for outputting given value as Json number.
`void` `writeNumber(String encodedValue)` Write method that can be used for custom numeric types that can not be (easily?) converted to "standard" Java number types.
`void` `writeRaw(char ch)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
`void` `writeRaw(char[] cbuf, int offset, int len)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
`void` `writeRaw(String text)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
`void` `writeRaw(String text, int offset, int len)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
`void` `writeRawUTF8String(byte[] text, int offset, int length)` Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String that is to be output as-is, without additional escaping (type of which depends on data format; backslashes for JSON).
`void` `writeStartArray()` Method for writing starting marker of a JSON Array value (character '['; plus possible white space decoration if pretty-printing is enabled).
`void` `writeStartObject()` Method for writing starting marker of a JSON Object value (character '{'; plus possible white space decoration if pretty-printing is enabled).
`void` `writeString(char[] text, int offset, int len)` Method for outputting a String value.
`void` `writeString(SerializableString text)` Method similar to `JsonGenerator.writeString(String)`, but that takes `SerializableString` which can make this potentially more efficient to call as generator may be able to reuse quoted and/or encoded representation.
`void` `writeString(String text)` Method for outputting a String value.
`void` `writeStringField(String fieldName, String value)` Convenience method for outputting a field entry ("member") that has a String value.
`void` `writeUTF8String(byte[] text, int offset, int len)` Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String which has not been escaped using whatever escaping scheme data format requires (for JSON that is backslash-escaping for control characters and double-quotes; for other formats something else).

Methods inherited from class com.fasterxml.jackson.core.base.GeneratorBase
`_cantHappen, _reportError, _reportUnsupportedOperation, _throwInternal, _writeSimpleObject, copyCurrentEvent, copyCurrentStructure, disable, enable, getCodec, getOutputContext, isClosed, isEnabled, setCodec, useDefaultPrettyPrinter, writeObject, writeRawValue, writeRawValue, writeRawValue, writeTree`

Methods inherited from class com.fasterxml.jackson.core.JsonGenerator
`canUseSchema, configure, setPrettyPrinter, setSchema, writeArrayFieldStart, writeBinary, writeBinary, writeBinaryField, writeBooleanField, writeNullField, writeNumberField, writeNumberField, writeNumberField, writeNumberField, writeNumberField, writeObjectField, writeObjectFieldStart`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### SURR1_FIRST

    protected static final int SURR1_FIRST

See Also:
  Constant Field Values

### SURR1_LAST

    protected static final int SURR1_LAST

See Also:
  Constant Field Values

### SURR2_FIRST

    protected static final int SURR2_FIRST

See Also:
  Constant Field Values

### SURR2_LAST

    protected static final int SURR2_LAST

See Also:
  Constant Field Values

### sOutputEscapes

    protected static final int[] sOutputEscapes

  This is the default set of escape codes, over 7-bit ASCII range (first 128 character codes), used for single-byte UTF-8 characters.

### _ioContext

    protected final IOContext _ioContext

### _outputStream

    protected final OutputStream _outputStream

  Underlying output stream used for writing JSON content.

### _outputEscapes

    protected int[] _outputEscapes

  Currently active set of output escape code definitions (whether and how to escape or not) for 7-bit ASCII range (first 128 character codes). Defined separately to make potentially customizable

### _maximumNonEscapedChar

    protected int _maximumNonEscapedChar

  Value between 128 (0x80) and 65535 (0xFFFF) that indicates highest Unicode code point that will not need escaping; or 0 to indicate that all characters can be represented without escaping. Typically used to force escaping of some portion of character set; for example to always escape non-ASCII characters (if value was 127).

  NOTE: not all sub-classes make use of this setting.

### _characterEscapes

    protected CharacterEscapes _characterEscapes

  Definition of custom character escapes to use for generators created by this factory, if any. If null, standard data format specific escapes are used.

### _outputBuffer

    protected byte[] _outputBuffer

  Intermediate buffer in which contents are buffered before being written using `_outputStream`.

### _outputTail

    protected int _outputTail

  Pointer to the position right beyond the last character to output (end marker; may be past the buffer)

### _outputEnd

    protected final int _outputEnd

  End marker of the output buffer; one past the last valid position within the buffer.

### _outputMaxContiguous

    protected final int _outputMaxContiguous

  Maximum number of `char`s that we know will always fit in the output buffer after escaping

### _charBuffer

    protected char[] _charBuffer

  Intermediate buffer in which characters of a String are copied before being encoded.

### _charBufferLength

    protected final int _charBufferLength

  Length of `_charBuffer`

### _entityBuffer

    protected byte[] _entityBuffer

  6 character temporary buffer allocated if needed, for constructing escape sequences

### _bufferRecyclable

    protected boolean _bufferRecyclable

  Flag that indicates whether the output buffer is recycable (and needs to be returned to recycler once we are done) or not.

Constructor Detail

### UTF8JsonGenerator

    public UTF8JsonGenerator(IOContext ctxt,
                             int features,
                             ObjectCodec codec,
                             OutputStream out)

### UTF8JsonGenerator

    public UTF8JsonGenerator(IOContext ctxt,
                             int features,
                             ObjectCodec codec,
                             OutputStream out,
                             byte[] outputBuffer,
                             int outputOffset,
                             boolean bufferRecyclable)

Method Detail

### version

    public Version version()

  Description copied from class: `GeneratorBase`
  Implemented with detection that tries to find "VERSION.txt" in same package as the implementation class.

  Specified by:
    `version` in interface `Versioned`
  Overrides:
    `version` in class `GeneratorBase`

### setHighestNonEscapedChar

    public JsonGenerator setHighestNonEscapedChar(int charCode)

  Description copied from class: `JsonGenerator`
  Method that can be called to request that generator escapes all character codes above specified code point (if positive value); or, to not escape any characters except for ones that must be escaped for the data format (if -1). To force escaping of all non-ASCII characters, for example, this method would be called with value of 127.

  Note that generators are NOT required to support setting of value higher than 127, because there are other ways to affect quoting (or lack thereof) of character codes between 0 and 127. Not all generators support concept of escaping, either; if so, calling this method will have no effect.

  Default implementation does nothing; sub-classes need to redefine it according to rules of supported data format.

  Overrides:
    `setHighestNonEscapedChar` in class `JsonGenerator`
  Parameters:
    `charCode` - Either -1 to indicate that no additional escaping is to be done; or highest code point not to escape (meaning higher ones will be), if positive value.

### getHighestEscapedChar

    public int getHighestEscapedChar()

  Description copied from class: `JsonGenerator`
  Accessor method for testing what is the highest unescaped character configured for this generator. This may be either positive value (when escaping configuration has been set and is in effect), or 0 to indicate that no additional escaping is in effect. Some generators may not support additional escaping: for example, generators for binary formats that do not use escaping should simply return 0.

  Overrides:
    `getHighestEscapedChar` in class `JsonGenerator`
  Returns:
    Currently active limitation for highest non-escaped character, if defined; or -1 to indicate no additional escaping is performed.

### setCharacterEscapes

    public JsonGenerator setCharacterEscapes(CharacterEscapes esc)

  Description copied from class: `JsonGenerator`
  Method for defining custom escapes factory uses for `JsonGenerator`s it creates.

  Overrides:
    `setCharacterEscapes` in class `JsonGenerator`

### getCharacterEscapes

    public CharacterEscapes getCharacterEscapes()

  Method for accessing custom escapes factory uses for `JsonGenerator`s it creates.

  Overrides:
    `getCharacterEscapes` in class `JsonGenerator`

### getOutputTarget

    public Object getOutputTarget()

  Description copied from class: `JsonGenerator`
  Method that can be used to get access to object that is used as target for generated output; this is usually either `OutputStream` or `Writer`, depending on what generator was constructed with. Note that returned value may be null in some cases; including case where implementation does not want to exposed raw source to caller. In cases where output has been decorated, object returned here is the decorated version; this allows some level of interaction between users of generator and decorator object.

  In general use of this accessor should be considered as "last effort", i.e. only used if no other mechanism is applicable.

  Overrides:
    `getOutputTarget` in class `JsonGenerator`

### writeStringField

    public final void writeStringField(String fieldName,
                                       String value)
                                throws IOException,
                                       JsonGenerationException

  Description copied from class: `JsonGenerator`
  Convenience method for outputting a field entry ("member") that has a String value. Equivalent to:

        writeFieldName(fieldName);
        writeString(value);

  Note: many performance-sensitive implementations override this method

  Overrides:
    `writeStringField` in class `JsonGenerator`
  Throws:
    `IOException`
    `JsonGenerationException`

### writeFieldName

    public final void writeFieldName(String name)
                              throws IOException,
                                     JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method for writing a field name (JSON String surrounded by double quotes: syntactically identical to a JSON String value), possibly decorated by white space if pretty-printing is enabled.

  Field names can only be written in Object context (check out JSON specification for details), when field name is expected (field names alternate with values).

  Specified by:
    `writeFieldName` in class `JsonGenerator`
  Throws:
    `IOException`
    `JsonGenerationException`

### writeFieldName

    public final void writeFieldName(SerializableString name)
                              throws IOException,
                                     JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method similar to `JsonGenerator.writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.

  Default implementation simple uses unprocessed name container in serialized String; implementations are strongly encouraged to make use of more efficient methods argument object has.

  Overrides:
    `writeFieldName` in class `GeneratorBase`
  Throws:
    `IOException`
    `JsonGenerationException`

### writeStartArray

    public final void writeStartArray()
                               throws IOException,
                                      JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method for writing starting marker of a JSON Array value (character '['; plus possible white space decoration if pretty-printing is enabled).

  Array values can be written in any context where values are allowed: meaning everywhere except for when a field name is expected.

  Specified by:
    `writeStartArray` in class `JsonGenerator`
  Throws:
    `IOException`
    `JsonGenerationException`

### writeEndArray

    public final void writeEndArray()
                             throws IOException,
                                    JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method for writing closing marker of a JSON Array value (character ']'; plus possible white space decoration if pretty-printing is enabled).

  Marker can be written if the innermost structured type is Array.

  Specified by:
    `writeEndArray` in class `JsonGenerator`
  Throws:
    `IOException`
    `JsonGenerationException`

### writeStartObject

    public final void writeStartObject()
                                throws IOException,
                                       JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method for writing starting marker of a JSON Object value (character '{'; plus possible white space decoration if pretty-printing is enabled).

  Object values can be written in any context where values are allowed: meaning everywhere except for when a field name is expected.

  Specified by:
    `writeStartObject` in class `JsonGenerator`
  Throws:
    `IOException`
    `JsonGenerationException`

### writeEndObject

    public final void writeEndObject()
                              throws IOException,
                                     JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method for writing closing marker of a JSON Object value (character '}'; plus possible white space decoration if pretty-printing is enabled).

  Marker can be written if the innermost structured type is Object, and the last written event was either a complete value, or START-OBJECT marker (see JSON specification for more details).

  Specified by:
    `writeEndObject` in class `JsonGenerator`
  Throws:
    `IOException`
    `JsonGenerationException`

### _writeFieldName

    protected final void _writeFieldName(String name)
                                  throws IOException,
                                         JsonGenerationException

  Throws:
    `IOException`
    `JsonGenerationException`

### _writeFieldName

    protected final void _writeFieldName(SerializableString name)
                                  throws IOException,
                                         JsonGenerationException

  Throws:
    `IOException`
    `JsonGenerationException`

### _writePPFieldName

    protected final void _writePPFieldName(String name,
                                           boolean commaBefore)
                                    throws IOException,
                                           JsonGenerationException

  Specialized version of `_writeFieldName`, off-lined to keep the "fast path" as simple (and hopefully fast) as possible.

  Throws:
    `IOException`
    `JsonGenerationException`

### _writePPFieldName

    protected final void _writePPFieldName(SerializableString name,
                                           boolean commaBefore)
                                    throws IOException,
                                           JsonGenerationException

  Throws:
    `IOException`
    `JsonGenerationException`

### writeString

    public void writeString(String text)
                     throws IOException,
                            JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method for outputting a String value. Depending on context this means either array element, (object) field value or a stand alone String; but in all cases, String will be surrounded in double quotes, and contents will be properly escaped as required by JSON specification.

  Specified by:
    `writeString` in class `JsonGenerator`
  Throws:
    `IOException`
    `JsonGenerationException`

### writeString

    public void writeString(char[] text,
                            int offset,
                            int len)
                     throws IOException,
                            JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method for outputting a String value. Depending on context this means either array element, (object) field value or a stand alone String; but in all cases, String will be surrounded in double quotes, and contents will be properly escaped as required by JSON specification.

  Specified by:
    `writeString` in class `JsonGenerator`
  Throws:
    `IOException`
    `JsonGenerationException`

### writeString

    public final void writeString(SerializableString text)
                           throws IOException,
                                  JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method similar to `JsonGenerator.writeString(String)`, but that takes `SerializableString` which can make this potentially more efficient to call as generator may be able to reuse quoted and/or encoded representation.

  Default implementation just calls `JsonGenerator.writeString(String)`; sub-classes should override it with more efficient implementation if possible.

  Overrides:
    `writeString` in class `GeneratorBase`
  Throws:
    `IOException`
    `JsonGenerationException`

### writeRawUTF8String

    public void writeRawUTF8String(byte[] text,
                                   int offset,
                                   int length)
                            throws IOException,
                                   JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String that is to be output as-is, without additional escaping (type of which depends on data format; backslashes for JSON). However, quoting that data format requires (like double-quotes for JSON) will be added around the value if and as necessary.

  Note that some backends may choose not to support this method: for example, if underlying destination is a `Writer` using this method would require UTF-8 decoding. If so, implementation may instead choose to throw a `UnsupportedOperationException` due to ineffectiveness of having to decode input.

  Specified by:
    `writeRawUTF8String` in class `JsonGenerator`
  Throws:
    `IOException`
    `JsonGenerationException`

### writeUTF8String

    public void writeUTF8String(byte[] text,
                                int offset,
                                int len)
                         throws IOException,
                                JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String which has not been escaped using whatever escaping scheme data format requires (for JSON that is backslash-escaping for control characters and double-quotes; for other formats something else). This means that textual JSON backends need to check if value needs JSON escaping, but otherwise can just be copied as is to output. Also, quoting that data format requires (like double-quotes for JSON) will be added around the value if and as necessary.

  Note that some backends may choose not to support this method: for example, if underlying destination is a `Writer` using this method would require UTF-8 decoding. In this case generator implementation may instead choose to throw a `UnsupportedOperationException` due to ineffectiveness of having to decode input.

  Specified by:
    `writeUTF8String` in class `JsonGenerator`
  Throws:
    `IOException`
    `JsonGenerationException`

### writeRaw

    public void writeRaw(String text)
                  throws IOException,
                         JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

  Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

  Specified by:
    `writeRaw` in class `JsonGenerator`
  Throws:
    `IOException`
    `JsonGenerationException`

### writeRaw

    public void writeRaw(String text,
                         int offset,
                         int len)
                  throws IOException,
                         JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

  Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

  Specified by:
    `writeRaw` in class `JsonGenerator`
  Throws:
    `IOException`
    `JsonGenerationException`

### writeRaw

    public final void writeRaw(char[] cbuf,
                               int offset,
                               int len)
                        throws IOException,
                               JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

  Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

  Specified by:
    `writeRaw` in class `JsonGenerator`
  Throws:
    `IOException`
    `JsonGenerationException`

### writeRaw

    public void writeRaw(char ch)
                  throws IOException,
                         JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

  Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

  Specified by:
    `writeRaw` in class `JsonGenerator`
  Throws:
    `IOException`
    `JsonGenerationException`

### writeBinary

    public void writeBinary(Base64Variant b64variant,
                            byte[] data,
                            int offset,
                            int len)
                     throws IOException,
                            JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method that will output given chunk of binary data as base64 encoded, as a complete String value (surrounded by double quotes). This method defaults

  Note: because Json Strings can not contain unescaped linefeeds, if linefeeds are included (as per last argument), they must be escaped. This adds overhead for decoding without improving readability. Alternatively if linefeeds are not included, resulting String value may violate the requirement of base64 RFC which mandates line-length of 76 characters and use of linefeeds. However, all `JsonParser` implementations are required to accept such "long line base64"; as do typical production-level base64 decoders.

  Specified by:
    `writeBinary` in class `JsonGenerator`
  Parameters:
    `b64variant` - Base64 variant to use: defines details such as whether padding is used (and if so, using which character); what is the maximum line length before adding linefeed, and also the underlying alphabet to use.
  Throws:
    `IOException`
    `JsonGenerationException`

### writeNumber

    public void writeNumber(int i)
                     throws IOException,
                            JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method for outputting given value as Json number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

  Specified by:
    `writeNumber` in class `JsonGenerator`
  Throws:
    `IOException`
    `JsonGenerationException`

### writeNumber

    public void writeNumber(long l)
                     throws IOException,
                            JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method for outputting given value as Json number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

  Specified by:
    `writeNumber` in class `JsonGenerator`
  Throws:
    `IOException`
    `JsonGenerationException`

### writeNumber

    public void writeNumber(BigInteger value)
                     throws IOException,
                            JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method for outputting given value as Json number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

  Specified by:
    `writeNumber` in class `JsonGenerator`
  Throws:
    `IOException`
    `JsonGenerationException`

### writeNumber

    public void writeNumber(double d)
                     throws IOException,
                            JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method for outputting indicate Json numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

  Specified by:
    `writeNumber` in class `JsonGenerator`
  Throws:
    `IOException`
    `JsonGenerationException`

### writeNumber

    public void writeNumber(float f)
                     throws IOException,
                            JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method for outputting indicate Json numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

  Specified by:
    `writeNumber` in class `JsonGenerator`
  Throws:
    `IOException`
    `JsonGenerationException`

### writeNumber

    public void writeNumber(BigDecimal value)
                     throws IOException,
                            JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method for outputting indicate Json numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

  Specified by:
    `writeNumber` in class `JsonGenerator`
  Throws:
    `IOException`
    `JsonGenerationException`

### writeNumber

    public void writeNumber(String encodedValue)
                     throws IOException,
                            JsonGenerationException

  Description copied from class: `JsonGenerator`
  Write method that can be used for custom numeric types that can not be (easily?) converted to "standard" Java number types. Because numbers are not surrounded by double quotes, regular `JsonGenerator.writeString(java.lang.String)` method can not be used; nor `JsonGenerator.writeRaw(java.lang.String)` because that does not properly handle value separators needed in Array or Object contexts.

  Note: because of lack of type safety, some generator implementations may not be able to implement this method. For example, if a binary json format is used, it may require type information for encoding; similarly for generator-wrappers around Java objects or Json nodes. If implementation does not implement this method, it needs to throw `UnsupportedOperationException`.

  Specified by:
    `writeNumber` in class `JsonGenerator`
  Throws:
    `IOException`
    `JsonGenerationException`

### writeBoolean

    public void writeBoolean(boolean state)
                      throws IOException,
                             JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method for outputting literal Json boolean value (one of Strings 'true' and 'false'). Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

  Specified by:
    `writeBoolean` in class `JsonGenerator`
  Throws:
    `IOException`
    `JsonGenerationException`

### writeNull

    public void writeNull()
                   throws IOException,
                          JsonGenerationException

  Description copied from class: `JsonGenerator`
  Method for outputting literal Json null value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

  Specified by:
    `writeNull` in class `JsonGenerator`
  Throws:
    `IOException`
    `JsonGenerationException`

### _verifyValueWrite

    protected final void _verifyValueWrite(String typeMsg)
                                    throws IOException,
                                           JsonGenerationException

  Specified by:
    `_verifyValueWrite` in class `GeneratorBase`
  Throws:
    `IOException`
    `JsonGenerationException`

### _verifyPrettyValueWrite

    protected final void _verifyPrettyValueWrite(String typeMsg,
                                                 int status)
                                          throws IOException,
                                                 JsonGenerationException

  Throws:
    `IOException`
    `JsonGenerationException`

### flush

    public final void flush()
                     throws IOException

  Description copied from class: `JsonGenerator`
  Method called to flush any buffered content to the underlying target (output stream, writer), and to flush the target itself as well.

  Specified by:
    `flush` in class `GeneratorBase`
  Throws:
    `IOException`

### close

    public void close()
               throws IOException

  Description copied from class: `JsonGenerator`
  Method called to close this generator, so that no more content can be written.

  Whether the underlying target (stream, writer) gets closed depends on whether this generator either manages the target (i.e. is the only one with access to the target -- case if caller passes a reference to the resource such as File, but not stream); or has feature `JsonGenerator.Feature.AUTO_CLOSE_TARGET` enabled. If either of above is true, the target is also closed. Otherwise (not managing, feature not enabled), target is not closed.

  Specified by:
    `close` in interface `Closeable`
  Overrides:
    `close` in class `GeneratorBase`
  Throws:
    `IOException`

### _releaseBuffers

    protected void _releaseBuffers()

  Specified by:
    `_releaseBuffers` in class `GeneratorBase`

### _writeBinary

    protected void _writeBinary(Base64Variant b64variant,
                                byte[] input,
                                int inputPtr,
                                int inputEnd)
                         throws IOException,
                                JsonGenerationException

  Throws:
    `IOException`
    `JsonGenerationException`

### _outputSurrogates

    protected final void _outputSurrogates(int surr1,
                                           int surr2)
                                    throws IOException

  Throws:
    `IOException`

### _decodeSurrogate

    protected final int _decodeSurrogate(int surr1,
                                         int surr2)
                                  throws IOException

  Throws:
    `IOException`

### _flushBuffer

    protected final void _flushBuffer()
                               throws IOException

  Throws:
    `IOException`

Copyright © 2012 fasterxml.com. All Rights Reserved.